import com.lowagie.text.Paragraph;

/* Cannot set indents on paragraphs added directly to Document objects.
 * (Can only set them if the para is added to a PdfPTable or ColumnText). */
public aspect NoIndentParaAddedToDocument {
		pointcut setters(Paragraph p):
			      (call (void com.lowagie.text.Paragraph.setFirstLineIndent(..)) || 
	               call (void com.lowagie.text.Paragraph.setIndentationLeft(..)) || 
	               call (void com.lowagie.text.Paragraph.setIndentationRight(..))) && target(p);
	
        tracematch(Paragraph p) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
            sym setIndent before:( setters(p)) && !within(dacapo..*);
            sym addToDocument before:( call (* com.lowagie.text.Document.add(..)) && args(p)) && !within(dacapo..*);

            setIndent addToDocument
			{
                throw new RuntimeException("Can only set indents on Paragraphs added to PdfPTables or ColumnTexts, not Documents.");
			}
        }
}
