import com.lowagie.text.Document;
import com.lowagie.text.pdf.*;

public aspect PathPaint {
	
		pointcut openContentByte(PdfWriter w):
			(call (com.lowagie.text.pdf.PdfContentByte PdfWriter.getDirectContent()) && target(w)) ||
                (call (com.lowagie.text.pdf.PdfContentByte.new(com.lowagie.text.pdf.PdfWriter)) && 
                args(w));
		
		pointcut pathConstruction(PdfContentByte cb):
            (call (* PdfContentByte+.moveTo(..)) ||
                    call (* PdfContentByte+.lineTo(..)) ||
                    call (* PdfContentByte+.curveTo(..)) ||
                    call (* PdfContentByte+.curveFromTo(..)) ||
                    call (* PdfContentByte+.closePath(..)) ||
                    call (* PdfContentByte+.Rectangle(..))) && target(cb);

		pointcut pathPainting(PdfContentByte cb):
            (call (* PdfContentByte+.stroke(..)) ||
                    call (* PdfContentByte+.closePathStroke(..)) ||
                    call (* PdfContentByte+.fill(..)) ||
                    call (* PdfContentByte+.eoFill(..)) ||
                    call (* PdfContentByte+.fillStroke(..)) ||
                    call (* PdfContentByte+.eoFillStroke(..)) ||
                    call (* PdfContentByte+.closePathFillStroke(..)) ||
                    call (* PdfContentByte+.closePathEoFillStroke(..)) ||
                    call (* PdfContentByte+.newPath(..))) && target(cb);
	
	    tracematch(Document d, PdfWriter w, PdfContentByte cb) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
            sym openDoc after returning(d):( call (com.lowagie.text.Document.new(..))) && !within(dacapo..*);
            sym openWr after returning(w):( call (* PdfWriter.getInstance(Document, ..)) && args(d, ..)) && !within(dacapo..*);
            sym openCB after returning(cb):( openContentByte(w)) && !within(dacapo..*);
            sym pathConstruction before:( pathConstruction(cb)) && !within(dacapo..*);
            sym pathPainting before:( pathPainting(cb)) && !within(dacapo..*);            
            sym closeDoc before:( call (void com.lowagie.text.Document.close()) && target(d)) && !within(dacapo..*);

            openDoc openWr openCB pathConstruction+ closeDoc
			{
                //if(System.getProperty("TMTEST_ACTIVE")!=null) {
                //throw new RuntimeException("Created a path without painting it.");
				//}
			}
		}
}
