package tracematches;

import jnt.scimark2.Stopwatch;

aspect StopWatch{
	
	pointcut start(Stopwatch s): call(* Stopwatch.start()) && target(s);
	pointcut stop(Stopwatch s): call(* Stopwatch.stop()) && target(s);
	pointcut resume(Stopwatch s): call(* Stopwatch.resume()) && target(s);
	pointcut read(Stopwatch s): call(* Stopwatch.read()) && target(s);
	pointcut reset(Stopwatch s): call(* Stopwatch.reset()) && target(s);

	tracematch(Stopwatch s) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
		
		sym reset after returning:( reset(s)) && !within(dacapo..*);
		sym start after returning:( start(s)) && !within(dacapo..*);
		sym read after returning:( read(s)) && !within(dacapo..*);
		
		reset read {
			//Stopwatch reset, not started but then read!
		}

	}

}