import jnt.scimark2.Stopwatch;

aspect StopWatch{
	
	pointcut start(Stopwatch s): call(* Stopwatch.start()) && target(s);
	pointcut stop(Stopwatch s): call(* Stopwatch.stop()) && target(s);
	pointcut resume(Stopwatch s): call(* Stopwatch.resume()) && target(s);
	pointcut read(Stopwatch s): call(* Stopwatch.read()) && target(s);
	pointcut reset(Stopwatch s): call(* Stopwatch.reset()) && target(s);

	tracematch(Stopwatch s) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
		
		sym start after returning:( start(s)) && !within(dacapo..*);
		sym stop after returning:( stop(s)) && !within(dacapo..*);
		
		start start {
			//Stopwatch started twice!
		}

	}
	
	tracematch(Stopwatch s) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
		
		sym start after returning:( start(s)) && !within(dacapo..*);
		sym resume after returning:( resume(s)) && !within(dacapo..*);
		sym stop after returning:( stop(s)) && !within(dacapo..*);
		
		stop stop {
			//Stopwatch stopped twice! (without being resumed)
		}

	}

	tracematch(Stopwatch s) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
		
		sym start after returning:( start(s)) && !within(dacapo..*);
		sym resume after returning:( resume(s)) && !within(dacapo..*);
		sym stop after returning:( stop(s)) && !within(dacapo..*);
		
		start resume {
			//Stopwatch resumed although it was never stopped!
		}

	}
	
	tracematch(Stopwatch s) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
		
		sym reset after returning:( reset(s)) && !within(dacapo..*);
		sym start after returning:( start(s)) && !within(dacapo..*);
		sym read after returning:( read(s)) && !within(dacapo..*);
		
		reset read {
			//Stopwatch reset, not started but then read!
		}

	}

}
